regina::NLayeredChainPair Class Reference
Standard Triangulations and Subcomplexes

Represents a layered chain pair component of a triangulation. More...

`#include <subcomplex/nlayeredchainpair.h>`

Inheritance diagram for regina::NLayeredChainPair:

## Public Member Functions

virtual | ~NLayeredChainPair ()
| Destroys this layered chain pair. More...
NLayeredChainPair * | clone () const
| Returns a newly created clone of this structure. More...
const NLayeredChain * | getChain (int which) const
| Returns the requested layered chain used to form this structure. More...
NManifold * | getManifold () const
| Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented. More...
NAbelianGroup * | getHomologyH1 () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the name of this triangulation as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the name of this triangulation in TeX format to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
Public Member Functions inherited from regina::NStandardTriangulation
virtual | ~NStandardTriangulation ()
| A destructor that does nothing. More...
std::string | getName () const
| Returns the name of this specific triangulation as a human-readable string. More...
std::string | getTeXName () const
| Returns the name of this specific triangulation in TeX format. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
Public Member Functions inherited from regina::ShareableObject
| ShareableObject ()
| Default constructor that does nothing. More...
virtual | ~ShareableObject ()
| Default destructor that does nothing. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Static Public Member Functions

static NLayeredChainPair * | isLayeredChainPair (const NComponent *comp)
| Determines if the given triangulation component is a layered chain pair. More...
Static Public Member Functions inherited from regina::NStandardTriangulation
static NStandardTriangulation * | isStandardTriangulation (NComponent *component)
| Determines whether the given component represents one of the standard triangulations understood by Regina. More...
static NStandardTriangulation * | isStandardTriangulation (NTriangulation *tri)
| Determines whether the given triangulation represents one of the standard triangulations understood by Regina. More...

## Additional Inherited Members

Protected Member Functions inherited from regina::boost::noncopyable
| noncopyable ()
| A constructor which does nothing. More...
| ~noncopyable ()
| A destructor which does nothing. More...

## Detailed Description

Represents a layered chain pair component of a triangulation.

A layered chain pair consists of two layered chains (as described by class NLayeredChain) glued together in a particular way.

Orient the hinge edges and diagonals of each chain so they all point in the same direction around the solid tori formed by each layered chain (a diagonal is an edge between the two top triangular faces or an edge between the two bottom triangular faces of a layered chain).

The two top faces of the first chain are glued to a top and bottom face of the second chain, and the two bottom faces of the first chain are glued to a top and bottom face of the second chain.

The four oriented diagonals are all identified as a single edge. Of the remaining unglued edges (two hinge edges and two non-hinge edges per chain), each hinge edge of one chain must be identified to a non-hinge edge of the other chain and vice versa. From here the face identifications are uniquely determined.

Note that a layered chain pair in which one of the chains contains only one tetrahedron is in fact a layered loop with a twist (see class NLayeredLoop).

All optional NStandardTriangulation routines are implemented for this class.

## Constructor & Destructor Documentation

regina::NLayeredChainPair::~NLayeredChainPair | ( |  | ) |

inline virtual

Destroys this layered chain pair.

## Member Function Documentation

NLayeredChainPair* regina::NLayeredChainPair::clone | ( |  | ) | const

Returns a newly created clone of this structure.

Returns
  a newly created clone.

const NLayeredChain * regina::NLayeredChainPair::getChain | ( | int | which | ) | const

inline

Returns the requested layered chain used to form this structure.

If the two chains have different lengths, the shorter chain will be chain 0 and the longer chain will be chain 1.

Parameters

  which | specifies which chain to return; this must be 0 or 1.

Returns
  the requested layered chain.

NAbelianGroup* regina::NLayeredChainPair::getHomologyH1 | ( |  | ) | const

virtual

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling NTriangulation::getHomologyH1() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this NStandardTriangulation describes an entire NTriangulation (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling NTriangulation::getHomologyH1() upon the associated real triangulation.

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented from regina::NStandardTriangulation.

NManifold* regina::NLayeredChainPair::getManifold | ( |  | ) | const

virtual

Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented.

If the 3-manifold cannot be recognised then this routine will return 0.

The details of which standard triangulations have 3-manifold recognition routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

It is expected that the number of triangulations whose underlying 3-manifolds can be recognised will grow between releases.

The 3-manifold will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the underlying 3-manifold.

Reimplemented from regina::NStandardTriangulation.

static NLayeredChainPair* regina::NLayeredChainPair::isLayeredChainPair | ( | const NComponent * | comp | ) |

static

Determines if the given triangulation component is a layered chain pair.

Parameters

  comp | the triangulation component to examine.

Returns
  a newly created structure containing details of the layered chain pair, or `null` if the given component is not a layered chain pair.

std::ostream & regina::NLayeredChainPair::writeName | ( | std::ostream & | out | ) | const

inline virtual

Writes the name of this triangulation as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

std::ostream & regina::NLayeredChainPair::writeTeXName | ( | std::ostream & | out | ) | const

inline virtual

Writes the name of this triangulation in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

void regina::NLayeredChainPair::writeTextLong | ( | std::ostream & | out | ) | const

inline virtual

Writes this object in long text format to the given output stream.

The output should provide the user with all the information they could want. The output should be human-readable, should not contain extremely long lines (so users can read the output in a terminal), and should end with a final newline.

The default implementation of this routine merely calls writeTextShort() and adds a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::ShareableObject.

The documentation for this class was generated from the following file:

- subcomplex/nlayeredchainpair.h

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).